<?php

echo '<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/2.0.0/jquery.min.js"></script>';

	//VALIDATE URL

	// Require libraries needed for gateway module functions.
	include("../../../includes/functions.php");
	include("../../../includes/gatewayfunctions.php");
	include("../../../includes/invoicefunctions.php");
	
	if (file_exists('../../../dbconnect.php')) 
	{
		include '../../../dbconnect.php';
	} 
	
	else if (file_exists('../../../init.php')) 
	{
		include '../../../init.php';
	} 
	
	else 
	{
		die('[ERROR] In modules/gateways/ipay88/ipay88_callback.php: include error: Cannot find dbconnect.php or init.php');
	}


	global $CONFIG;
		
	$GATEWAY = getGatewayVariables(ipay88_kredivo);
	
	if (!$GATEWAY["type"]) die("Module Not Activated"); //Checks gateway module is active before accepting callback	
				
	if (isset($_REQUEST['invoiceId'])) 
	{
		// Gateway Specific Variables
		$ipay88_kredivo_merchant_code	= $GATEWAY['merchant_code_kredivo'];
		$ipay88_kredivo_merchant_key	= $GATEWAY['merchant_key_kredivo'];
		$ipay88_kredivo_action			= $GATEWAY['environment_kredivo'];
		
		if($ipay88_kredivo_action == "on")
		{ 
			$action_ipay88 = "https://sandbox.ipay88.co.id/ePayment/WebService/PaymentAPI/Checkout";
		}
	
		else
		{
			$action_ipay88 = "https://payment.ipay88.co.id/ePayment/WebService/PaymentAPI/Checkout";
		}
		
		
		//Get Post
		$invoiceId 		= $_POST['invoiceId'];
		$description 	= $_POST['description'];
		$amount 		= $_POST['amount'];
		$currencyCode 	= $_POST['currencyCode'];
		
		$firstname 		= $_POST['firstname'];
		$lastname 		= $_POST['lastname'];
		$fullname 		= $_POST['fullname'];
		$email 			= $_POST['email'];
		$address1 		= $_POST['address1'];
		$address2 		= $_POST['address2'];
		$city 			= $_POST['city'];
		$state 			= $_POST['state'];
		$postcode 		= $_POST['postcode'];
		$country 		= $_POST['country'];
		$phone 			= $_POST['phone'];
			
			
		//Payment ID
		$payment_id = '55';
		
		
		//Ref No
		$RefNo_response = $invoiceId;
		
		
		//Amount
		$total			= $amount;
		$orderAmount	= number_format($total, 2, ".", "");
		$HashAmount 	= str_replace(".","",str_replace(",","",$orderAmount));	
	
			
		//Date HIS
		date_default_timezone_set('Asia/Jakarta');	
		
		//Generate Request Signature
		$MechantKey 	= $ipay88_kredivo_merchant_key;
		$MerchantCode 	= $ipay88_kredivo_merchant_code;
		$Amount			= $HashAmount; 
		$Currency		= $currencyCode;
		$ipaySignature 	= "";	
		
		$encrypt		= sha1($MechantKey.$MerchantCode.$RefNo_response.$Amount.$Currency);		
		
		for ($i=0; $i<strlen($encrypt); $i=$i+2)
		{
			$ipaySignature .= chr(hexdec(substr($encrypt,$i,2)));
		}
		
		$ipaySignature = base64_encode($ipaySignature);
		
		
		//Invoice URL
		$viewinvoice = $CONFIG['SystemURL']."/viewinvoice.php?id=".$invoiceId;
		
		
		//Response URL
		$responseurl = $CONFIG['SystemURL']."/modules/gateways/callback/ipay88_kredivo_response.php";
			
			
		//Backend URL
		$backendurl =  $CONFIG['SystemURL']."/modules/gateways/callback/ipay88_kredivo_backend.php";
		
		
		//ITEM TRANSACTION-------------------------------------------------------------------------------------------	
		$table 	= "tblinvoiceitems";
		$fields = "invoiceid, type, description, amount, taxed";
		$where 	= array("invoiceid" => $invoiceId);
		$result = select_query($table, $fields, $where);
		$data 	= mysql_fetch_array($result);
		
		$product_name = "Package: ".$data['description']."";	
						
		//--value array
		$value_id		= array( "0" => "1");	
		$value_name		= array( "0" => $product_name);
		$value_quantity	= array( "0" => "1");
		$value_amount	= array( "0" => $Amount);
		$value_type		= array( "0" => "Package Hosting");
		$value_url		= array( "0" => "");
							

		//Make an array that save value based on key from array before					
		$item_list 	= 	array_map(function () 
							{
								return (func_get_args());
							}, $value_id, $value_name, $value_quantity, $value_amount, $value_type, $value_url);
		
	
		//Rename key of array	
		foreach ($item_list as $key => $value )
		{
			$item_list[$key] ['id'] 		= $item_list[$key] ['0'];
			$item_list[$key] ['name'] 		= $item_list[$key] ['1'];
			$item_list[$key] ['quantity']	= $item_list[$key] ['2'];
			$item_list[$key] ['amount'] 	= $item_list[$key] ['3'];
			$item_list[$key] ['type'] 		= $item_list[$key] ['4'];
			$item_list[$key] ['url'] 		= $item_list[$key] ['5'];
			
			unset($item_list[$key]['0']);
			unset($item_list[$key]['1']);
			unset($item_list[$key]['2']);
			unset($item_list[$key]['3']);
			unset($item_list[$key]['4']);
			unset($item_list[$key]['5']);
		}
				
		//Shipping		
		$shipping_HashAmount = "000" ;		
		
		//Voucher
		$discount_HashAmount = "000" ;
		
		//Tax Fee
		$taxfee_HashAmount = "000" ;
					
		
		$array_one		=	array(
									"0"		=> "taxfee",
									"1"		=> "shippingfee",
									"2"		=> "discount",
								);
							
		$array_two		=	array(
									"0"		=> "Tax Fee",
									"1"		=> "Shipping Fee",
									"2"		=> "Discount",
								);	
							
		$array_three	=	array(
									"0"	=> $taxfee_HashAmount,
									"1"	=> $shipping_HashAmount,
									"2"	=> $discount_HashAmount
								);
											
		$array_four		=	array(
									"0"	=> "1",
									"1"	=> "1",
									"2"	=> "1",
								);		
										

		//Make an array that save value based on key from array before					
		$amount_list 	= 	array_map(function () 
							{
								return (func_get_args());
							}, $array_one, $array_two, $array_three, $array_four);
		
	
		//Rename key of array	
		foreach ($amount_list as $key => $value )
		{
			$amount_list[$key] ['id'] 		= $amount_list[$key] ['0'];
			$amount_list[$key] ['name'] 	= $amount_list[$key] ['1'];
			$amount_list[$key] ['amount']	= $amount_list[$key] ['2'];
			$amount_list[$key] ['quantity'] = $amount_list[$key] ['3'];
			
			unset($amount_list[$key]['0']);
			unset($amount_list[$key]['1']);
			unset($amount_list[$key]['2']);
			unset($amount_list[$key]['3']);
		}
		
		//Add array 
		$amount_list[1]["parent_type"] 	= "SELLER";
		$amount_list[1]["parent_id"] 	= "SELLER".$invoiceId."";
		
		//Merge into one array
		$itemTransactions = array_merge($item_list, $amount_list);		

		
		//SHIPPING AND BILLING ADDRESS--------------------------------------------------------------------
	
		$ShippingAddress = array(
									'FirstName'		=> $firstname,
									'LastName'		=> $lastname,
									'Address'		=> $address1." ".$address2,
									'City'			=> $city,
									'PostalCode'	=> $postcode,
									'Phone'			=> $phone,
									'CountryCode'	=> $country,
						   );
					
		$BillingAddress = array(
									'FirstName'		=> $firstname,
									'LastName'		=> $lastname,
									'Address'		=> $address1." ".$address2,
									'City'			=> $city,
									'PostalCode'	=> $postcode,
									'Phone'			=> $phone,
									'CountryCode'	=> $country,
						   );
						   
		//GENERATE JSON-------------------------------------------------------------------------------------			   
		
		$ipay88_Obj = new stdClass();
		
		$ipay88_Obj->MerchantCode 				= $MerchantCode;
		$ipay88_Obj->PaymentId 					= $payment_id;
		$ipay88_Obj->Currency 					= $Currency;
		$ipay88_Obj->RefNo						= $invoiceId;
		$ipay88_Obj->Amount						= $HashAmount;
		$ipay88_Obj->ProdDesc					= $product_name;
		$ipay88_Obj->UserName					= $firstname." ".$lastname;
		$ipay88_Obj->UserEmail					= $email;
		$ipay88_Obj->UserContact				= $phone;
		$ipay88_Obj->Remark						= "Transaction date ".date('Y-m-d H:i:s');
		$ipay88_Obj->Lang						= "UTF-8";
		$ipay88_Obj->ResponseURL				= $responseurl;
		$ipay88_Obj->BackendURL					= $backendurl;
		$ipay88_Obj->Signature					= $ipaySignature;
		$ipay88_Obj->xfield1					= "";
		//$ipay88_Obj->FullTransactionAmount	= $HashFullTransactionAmount;
		//$ipay88_Obj->MiscFee					= $MiscFee;
	
		$ipay88_Obj->itemTransactions			= $itemTransactions;				  
		$ipay88_Obj->ShippingAddress			= $ShippingAddress;
		$ipay88_Obj->BillingAddress				= $BillingAddress;

	
		$ipay88_JSON = json_encode($ipay88_Obj, JSON_UNESCAPED_SLASHES);
			
		$url  	 	 = $action_ipay88;	
		$options 	 = array(
								'http' 	=> array(
													'header'  	=> "Content-type: application/json\r\n",
													'method'  	=> 'POST',
													'content' 	=> $ipay88_JSON,
												)
							);
										
		$context		= stream_context_create($options);
		$result 		= file_get_contents($url, false, $context);
		
	
		//JSON FAILED	
		if ($result === FALSE) 
		{	
			logTransaction($GATEWAY["name"], $_POST, "Unsuccessful");
			
			$table	= "tblhosting";
			$update	= array("domainstatus"	=> "Cancelled");
			$where	= array("orderid" 		=> $id);
			
			update_query($table, $update, $where);	
			
			$table	= "tblorders";
			$update	= array("status"	=> "Cancelled");
			$where	= array("invoiceid" => $invoiceId);
			
			update_query($table, $update, $where);			
			
			$table	= "tblorders";
			$update	= array("notes"		=> "iPay88 Payment Failed. Error description: Connection failed with iPay88 JSON.");
			$where	= array("invoiceid" => $invoiceId);
			
			update_query($table, $update, $where);	
																			
    		header("Location:".$viewinvoice."&paymentfailed=true");
			exit();			
		}

		else
		{
			$data = json_decode($result, true);
					
			//Status Fail
			if ($data['Status'] == "0")
			{	
				$error_response = $data['ErrDesc'];
							
				//update status payment failed + create message
				$table	= "tblhosting";
				$update	= array("domainstatus"	=> "Cancelled");
				$where	= array("orderid" 		=> $id);
				
				update_query($table, $update, $where);	
				
				$table	= "tblorders";
				$update	= array("status"	=> "Cancelled");
				$where	= array("invoiceid" => $invoiceId);
				
				update_query($table, $update, $where);			
				
				$table	= "tblorders";
				$update	= array("notes"		=> "iPay88 Payment Failed. Json already connected. Error description: ".$error_response.".");
				$where	= array("invoiceid" => $invoiceId);
				
				update_query($table, $update, $where);	
																								
    			header("Location:".$viewinvoice."&paymentfailed=true");
				exit();					
			}
		
			//Status Pending
			else
			{
				//Signature from iPay88
				$ipay88_signature  		= $data['Signature'];
			
				//Generate Response Signature				
				$MechantKey_response 	= $MechantKey;
				$MerchantCode_response 	= $MerchantCode;
				$PaymentId_response		= $data['PaymentId'];
				$Amount_response		= $data['Amount'];
				$Currency_response		= $data['Currency'];
				$Status_response		= $data['Status'];
				$merchant_signature 	= "";
			
				$str = sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$Amount_response.$Currency_response.$Status_response);		
				
				for ($i=0; $i<strlen($str); $i=$i+2)
				{
					$merchant_signature .= chr(hexdec(substr($str,$i,2)));
				}
		 
				$merchant_signature = base64_encode($merchant_signature);
			
				//Signature match
				if($merchant_signature == $merchant_signature)
				{
						
					//Update private message
					$table	= "tblorders";
					$update	= array("notes"		=> "iPay88 Payment Pending. Json already connected.");
					$where	= array("invoiceid" => $invoiceId);
					
					update_query($table, $update, $where);	
									
					$checkout	= $data['CheckoutURL'];
					
					$load_file_function = '
					<script language="JavaScript">
					$(document).ready(function() 
					{
						document.ipay88_request_paramaters.submit();
					});
					</script>';
		
					echo $load_file_function;
				
					echo "<body>";
					echo "<form  name='ipay88_request_paramaters' ACTION='".$checkout."' method='POST'>";
					echo "</form>";
				}
		
				//Signature is not match
				else					
				{					
					//update status payment failed + create message
					$table	= "tblhosting";
					$update	= array("domainstatus"	=> "Cancelled");
					$where	= array("orderid" 		=> $id);
					
					update_query($table, $update, $where);	
					
					$table	= "tblorders";
					$update	= array("status"	=> "Cancelled");
					$where	= array("invoiceid" => $invoiceId);
					
					update_query($table, $update, $where);			
					
					$table	= "tblorders";
					$update	= array("notes"		=> "Error description: Signature not match.");
					$where	= array("invoiceid" => $invoiceId);
					
					update_query($table, $update, $where);	
																									
					header("Location:".$viewinvoice."&paymentfailed=true");
					exit();								
				}
			
			}
		}		

	}
	
	else
	{	
		header("Location:".$CONFIG['SystemURL'].""); /* Redirect browser */
		exit();
	}
	
?>




